org.freedesktop.UDisks2.Job

## org.freedesktop.UDisks2.Job org.freedesktop.UDisks2.Job — Long-running tasks |

## Methods

    Cancel (IN  a{sv} options);

## Signals

    Completed (b success,
               s message);

## Properties

    Progress         readable   d
    StartTime        readable   t
    ExpectedEndTime  readable   t
    Objects          readable   ao

## Description

Some operations may take a long time (hours) to complete, that is, to actually send the D-Bus reply message back. One example of such an operation is the Format() method that is used to format a block device.

When such operations are initated, a job object implementing this interface may be created so the progress can be tracked by the caller (and also other observers).

The object(s) that a job affects (such as block devices or drives) can be determined by looking at the "Objects" property. Among other things, this can be used to draw a spinner in the user interface next to e.g. an icon for the drive or device in question.

A job may convey progress (if the underlying tool used supports it), see the "ExpectedEndTime" property.

When a job completes, the "Completed" signal is emitted.

To cancel a job use the Cancel() method. This will cause the job to complete (with `success` set to `FALSE`) and the D-Bus method used to initiate the operation to return, usually returning the `org.freedesktop.UDisks2.Error.Cancelled` error.

## Method Details

### The Cancel() method

    Cancel (IN  a{sv} options);

Cancels the job.

`IN a{sv} `options``: | Options (currently unused except for standard options).

## Signal Details

### The "Completed" signal

    Completed (b success,
               s message);

Emitted when a job completes.

`b `success``: | If `TRUE`, the job completed successfully.
`s `message``: | A message describing the completion of the job, e.g. an error message.

## Property Details

### The "Progress" property

    Progress  readable   d

How much progress has been made. Values are in the range 0 to 1.

### The "StartTime" property

    StartTime  readable   t

The point in time (seconds since the Unix Epoch) that the job was started.

### The "ExpectedEndTime" property

    ExpectedEndTime  readable   t

The expected point in time (seconds since the Unix Epoch) that the job will complete or 0 if unknown.

### The "Objects" property

    Objects  readable   ao

The objects that the job is related to, if any.